%X-Sun-Data-Type: default
%X-Sun-Data-Name: hanoi5
%X-Sun-Charset: us-ascii
%X-Sun-Content-Lines: 180


% Hanoi 4 disks 
% modified from hanoi.pl by in/24.6.1997 see %ini comments


diff(X,Y):- block(X),block(Y),not eq(X,Y).

clear(X,T):- block(X),time(T),not occ(X,T).
occ(X,T):- block(X),small(Y,X),time(T),on(Y,X,T).



aPP(X,Y,T):-moveable(X),time(T),block(Y),small(X,Y),small(X,Z),diff(Z,Y),on(X,Z,T),clear(X,T),clear(Y,T),switch(X,T),not other(X,Y,T).

other(X,Y,T):-moveable(X),time(T),block(Y),small(X,Y),small(X,Z),diff(Y,Z),aPP(X,Z,T).

other(X,Y,T):-moveable(X),block(Y),time(T),small(X,Y),small(Z,Y),diff(X,Z),diff(Y,Z),aPP(Z,Y,T).

switch(X,T):-moveable(X),time(T),not blocked(X,T).
blocked(X,T):-moveable(X),time(T),not switch(X,T).

blocked(X,T):-moveable(X),time(T),occ(X,T).

on(X,Y,T1):- time(T1),prevtime(T1,T2),moveable(X),block(Y),small(X,Y),on(X,Y,T2),blocked(X,T2).

on(X,Y,T1):- time(T1),prevtime(T1,T2),moveable(X),small(X,Y),aPP(X,Y,T2).



inco:- time(T),clear(peg1,T),clear(peg2,T),clear(peg3,T).
inco:- time(T),moveable(X),moveable(Y),moveable(Z),moveable(K),diff(X,Y),diff(X,Z),diff(X,K),diff(Y,Z),diff(Y,K),diff(Z,K),clear(X,T),clear(Y,T),clear(Z,T),clear(K,T).
inco:- time(T),moveable(X),moveable(Y),moveable(Z),static(K),clear(K,T),diff(X,Y),diff(X,Z),diff(Y,Z),clear(X,T),clear(Y,T),clear(Z,T).

block(a).
block(b).
block(c).
block(d).
%ini block(e).
%block(f).
%block(g).
%block(h).
%block(i).	
%block(j).
%block(k).
%block(l). 
%block(m).
%block(n).
%block(o).


block(peg1).
block(peg2).
block(peg3).

static(peg1).
static(peg2).
static(peg3).

moveable(a).
moveable(b).
moveable(c).
moveable(d).
%ini moveable(e).
%moveable(f).
%moveable(g).
%moveable(h).
%moveable(i).	
%moveable(j).
%moveable(k).
%moveable(l). 
%moveable(m).
%moveable(n).
%moveable(o).

eq(a,a).
eq(b,b).
eq(c,c).
eq(d,d).
eq(e,e).
%eq(f,f).
%eq(g,g).
%eq(h,h).
%eq(i,i).
%eq(j,j).
%eq(k,k).
%eq(l,l).
%eq(m,m).
%eq(n,n).
%eq(o,o).
%eq(table,table).

eq(peg1,peg1).
eq(peg2,peg2).
eq(peg3,peg3).

time(t0).
time(t1).
time(t2).
time(t3).
time(t4).
time(t5).
time(t6).
time(t7).
time(t9).
time(t8).
time(t10).
time(t11).
time(t12).
time(t13).
time(t14).
time(t15).
time(t16).
time(t17).
time(t18).
time(t19).
time(t20).

prevtime(t1,t0).
prevtime(t2,t1).
prevtime(t3,t2).
prevtime(t4,t3).
prevtime(t5,t4).
prevtime(t6,t5).
prevtime(t7,t6).
prevtime(t8,t7).
prevtime(t9,t8).
prevtime(t10,t9).
prevtime(t11,t10).
prevtime(t12,t11).
prevtime(t13,t12).
prevtime(t14,t13).
prevtime(t15,t14).
prevtime(t16,t15).
prevtime(t17,t16).
prevtime(t18,t17).
prevtime(t19,t18).
prevtime(t20,t19).

small(e,d).
small(e,c).
small(e,b).
small(e,a).
small(e,peg1).
small(e,peg2).
small(e,peg3).

small(d,c).
small(d,b).
small(d,a).
small(d,peg1).
small(d,peg2).
small(d,peg3).

small(c,b).
small(c,a).
small(c,peg1).
small(c,peg2).
small(c,peg3).
small(b,a).
small(b,peg1).
small(b,peg2).
small(b,peg3).
small(a,peg1).
small(a,peg2).
small(a,peg3).



%ini on(e,d,t0).
on(d,c,t0).
on(c,b,t0).
on(b,a,t0).
on(a,peg1,t0).
%ini clear(e,t0).
%ini e -> d
clear(d,t0).
clear(peg2,t0).
clear(peg3,t0).

%ini compute 1 {on(e,d,t20),on(d,c,t20),on(c,b,t20),on(b,a,t20),on(a,peg3,t20),not inco}
%ini new goal
compute 1 {on(d,c,t20),on(c,b,t20),on(b,a,t20),on(a,peg3,t20),not inco}




