%X-Sun-Data-Type: default
%X-Sun-Data-Name: logistics
%X-Sun-Charset: us-ascii
%X-Sun-Content-Lines: 188


diff(X,Y):- loc(X),loc(Y),not eq(X,Y).
%diff(X,Y):- veh(X),veh(Y),not eq(X,Y).

in(X,Y,T):- veh(Y),obj(X),time(T),prev(T,T1),at(Y,Z,T1),corloc(Y,Z),at(X,Z,T1),lOAD_OBJ(X,Y,T1).


in(X,Y,T):- veh(Y),obj(X),time(T),prev(T,T1),in(X,Y,T1),not uN_LOAD(X,Y,T1).

at(X,Y,T):- obj(X),loc(Y),veh(Z),at(Z,Y,T1),prev(T,T1),uN_LOAD(X,Z,T1).

at(X,Y,T):- obj(X),loc(Y),time(T),prev(T,T1),at(X,Y,T1),veh(Z),not loaded(X,T1).

loaded(X,T):-obj(X),time(T),veh(Z),lOAD_OBJ(X,Z,T). 

at(X,Y,T):- veh(X),corloc(X,Y),time(T),prev(T,T1),at(X,Z,T1),diff(Z,Y),corloc(X,Z),fROM(X,Z,T1),tOW(X,Y,T1).

at(X,Y,T):- veh(X),corloc(X,Y),time(T),prev(T,T1),at(X,Y,T1),not fROM(X,Y,T1).


fROM(X,Z,T):- veh(X),time(T),corloc(X,Z),at(X,Z,T),moves(X,T).


moves(X,T):-veh(X),time(T),not blocked(X,T).
blocked(X,T):-veh(X),time(T),not moves(X,T).

tOW(X,Y,T):- veh(X),corloc(X,Y),time(T),fROM(X,Z,T),diff(Y,Z),not otherto(X,Y,T).
otherto(X,Y,T):-veh(X),corloc(X,Y),time(T),corloc(X,Z),diff(Y,Z),tOW(X,Z,T). 


lOAD_OBJ(X,Y,T):- veh(Y),obj(X),time(T),at(Y,Z,T),corloc(Y,Z),at(X,Z,T),app1(X,T),not otherload(X,Y,T).
app1(X,T):- obj(X),time(T),not blocked1(X,T). 
blocked1(X,T):- obj(X),time(T),not app1(X,T).
otherload(X,Y,T):- veh(Y),obj(X),time(T),veh(Z),diff(Y,Z),lOAD_OBJ(X,Z,T).

uN_LOAD(X,Y,T):-veh(Y),obj(X),at(Y,Z,T),corloc(Y,Z),in(X,Y,T),time(T),app2(X,T).
%uN_LOAD(X,Y,T):-veh(Y),obj(X),in(X,Y,T),time(T),app2(X,T).
app2(X,T):- obj(X),time(T),not blocked2(X,T).
blocked2(X,T):-obj(X),time(T),not app2(X,T).





inco:- time(T),veh(Y),obj(X),veh(Z),diff(Y,Z),in(X,Y,T),in(X,Z,T).
inco:- time(T),obj(X),loc(Y),loc(Z),diff(Y,Z),at(X,Y,T),at(X,Z,T).
inco:- time(T),veh(X),corloc(X,Y),corloc(X,Z),diff(Y,Z),at(X,Y,T),at(X,Z,T).

%More Cons

inco:- time(T),obj(X),loc(Y),at(X,Y,T),veh(Z),in(X,Z,T).





eq(frpo,frpo).
eq(frap,frap).
eq(sbpo,sbpo).
eq(sbap,sbap).
eq(zuap,zuap).
eq(zupo,zupo).
eq(atpo,atpo).
eq(atap,atap).


%eq(frtruck,frtruck).
%eq(sbtruck,sbtruck).
%eq(plane,plane).

diff(frtruck,sbtruck).
diff(frtruck,plane1).
diff(frtruck,zutruck).
diff(frtruck,plane2).
diff(frtruck,attruck).
diff(sbtruck,frtruck).
diff(sbtruck,plane1).
diff(sbtruck,plane2).
diff(sbtruck,zutruck).
diff(sbtruck,attruck).

diff(attruck,frtruck).
diff(attruck,plane1).
diff(attruck,plane2).
diff(attruck,zutruck).
diff(attruck,sbtruck).

diff(plane1,sbtruck).
diff(plane1,frtruck).
diff(plane1,zutruck).
diff(plane1,plane2).
diff(plane1,attruck).
diff(plane2,sbtruck).
diff(plane2,frtruck).
diff(plane2,zutruck).
diff(plane2,plane1).
diff(plane2,attruck).

loc(frpo).
loc(frap).
loc(sbpo).
loc(sbap).
loc(zupo).
loc(zuap).
loc(atpo).
loc(atap).

veh(frtruck).
veh(sbtruck).
veh(zutruck).
veh(plane1).
veh(plane2).
veh(attruck).

obj(pac1).
obj(pac3).
obj(pac5).
obj(pac2).
obj(pac4).
obj(pac6).
obj(pac7).

corloc(frtruck,frpo).
corloc(frtruck,frap).
corloc(sbtruck,sbpo).
corloc(sbtruck,sbap).
corloc(zutruck,zupo).
corloc(zutruck,zuap).
corloc(attruck,atpo).
corloc(attruck,atap).
corloc(plane1,frap).
corloc(plane1,sbap).
corloc(plane1,zuap).
corloc(plane2,frap).
corloc(plane2,sbap).
corloc(plane2,zuap).
corloc(plane1,atap).
corloc(plane2,atap).

time(t0).
time(t1).
time(t2).
time(t3).
time(t4).
time(t5).
time(t6).
time(t7).
%time(t9).
time(t8).
%time(t10).
%time(t11).

prev(t1,t0).
prev(t2,t1).
prev(t3,t2).
prev(t4,t3).
prev(t5,t4).
prev(t6,t5).
prev(t7,t6).
prev(t8,t7).
%prev(t9,t8).
%prev(t10,t9).
%prev(t11,t10).

at(pac1,zupo,t0).
at(pac2,zupo,t0).
at(pac3,zupo,t0).
at(pac4,atpo,t0).
at(pac5,frpo,t0).
at(pac6,frpo,t0).
at(pac7,atpo,t0).

at(frtruck,frpo,t0).
at(plane1,zuap,t0).
at(plane2,zuap,t0).
at(sbtruck,sbpo,t0).
at(zutruck,zupo,t0).
at(attruck,atpo,t0).






compute 1 {at(pac1,frpo,t8),at(pac2,atpo,t8),at(pac3,sbpo,t8),at(pac5,zupo,t8),at(pac7,zupo,t8),at(pac4,sbap,t8),at(pac6,atap,t8),not inco}


